Attribute VB_Name = "CSMiscellaneous"
Option Explicit

Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Const GWL_STYLE = (-16)
Public Const WS_CHILD = &H40000000

Public m_JumpLink As Boolean

' Public m_UserControl As Object
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
#If UNICODE Then
    Public Declare Function SendMessage Lib "user32" Alias "SendMessageW" (ByVal hwnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
#Else
    Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal uMgs As Long, ByVal wParam As Long, lParam As Any) As Long
#End If
Public Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long

'Messages to relay to ToolTip
Public Const WM_USER = &H400
Public Const WM_NOTIFY = &H4E
Public Const WM_MOUSEMOVE = &H200
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208

'ToolTip style
Public Const TTF_IDISHWND = &H1

'Tool Tip messages
Public Const TTM_ACTIVATE = (WM_USER + 1)
#If UNICODE Then
    Public Const TTM_ADDTOOLW = (WM_USER + 50)
    Public Const TTM_ADDTOOL = TTM_ADDTOOLW
#Else
    Public Const TTM_ADDTOOLA = (WM_USER + 4)
    Public Const TTM_ADDTOOL = TTM_ADDTOOLA
#End If
Public Const TTM_RELAYEVENT = (WM_USER + 7)

Public Const WND_WIDTH = 223
Public Const WND_HEIGHT = 237
Public Const WND2_HEIGHT = 167
Public Const WND2_WIDTH = 288

Const WND_W_ABOUT = 223
Const WND_W_GETDATES = 288
Const WND_W_DATEOUT = 321
Const WND_W_INPUT = 311
Const WND_W_SELECT = 214

Const WND_H_ABOUT = 93 + 16
Const WND_H_GETDATES = 151 + 16
Const WND_H_DATEOUT = 181 + 16
Const WND_H_INPUT = 120 + 16
Const WND_H_SELECT = 212

' Set some constant values (from WIN32API.TXT).
Public Const conHwndTopmost = -1
Public Const conHwndNoTopmost = -2
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1
Public Const conSwpNoActivate = &H10
Public Const conSwpShowWindow = &H40

Public Sub Capture(Optional ByVal hwnd As Long = 0)
    
    On Error Resume Next
    If hwnd <> 0 Then
        SetCapture (hwnd)
    Else
        ReleaseCapture
    End If
        
End Sub

Public Function ShowTopmost(F As Form, Optional ByVal lft As Long = 0, Optional ByVal tp As Long = 0, Optional ByVal wd As Long = WND_W_SELECT, Optional ByVal ht As Long = WND_H_SELECT) As Boolean
    
    On Error Resume Next
            
    SetWindowPos F.hwnd, conHwndTopmost, F.ScaleX(F.Left, vbTwips, vbPixels), F.ScaleY(F.Top, vbTwips, vbPixels), F.ScaleWidth + 4, F.ScaleHeight + 25, conSwpNoActivate
    F.Show
    If Err <> 0 And F.Visible = False Then
        F.Show 1
    Else
        F.ZOrder
    End If
   
End Function


Public Function LongToBytes(ByVal lVal As Long) As Variant

    LongToBytes = Hex(lVal)

End Function

Public Function BytesToLong(ByVal sVal As String) As Variant

    On Error Resume Next
    Dim l As Double
    Const MaxLong = &H7FFFFFFF
    Const Sign = &H80000000
    Dim signed As Boolean
    
    sVal = Left(sVal, 4)
    l = 0
    If Len(sVal) >= 4 Then
        signed = (CLng(Asc(Mid(sVal, 4, 1))) And &H80)
        If signed Then
            l = l + ((CLng(Asc(Mid(sVal, 4, 1))) And &H7F) * (256 ^ 3))
        Else
            l = l + (CLng(Asc(Mid(sVal, 4, 1))) * (256 ^ 3))
        End If
    End If
    If Len(sVal) >= 3 Then l = l + (CLng(Asc(Mid(sVal, 3, 1))) * (256 ^ 2))
    If Len(sVal) >= 2 Then l = l + (CLng(Asc(Mid(sVal, 2, 1))) * 256)
    l = l + CLng(Asc(Mid(sVal, 1, 1)))
    If signed Then l = Sign + l
    BytesToLong = l

End Function

Public Function FileExists(ByVal newName As String) As Boolean

    On Error Resume Next
    Dim l As Long
    Err.Clear
    l = GetAttr(newName)
    FileExists = (Err = 0 And l <> 16)
    
End Function
Public Sub TrimNulls(newString As String)
    
    If InStr(1, newString, Chr$(0)) > 0 Then newString = Left(newString, InStr(1, newString, Chr$(0)) - 1)

End Sub


